;- TOP

; Komment   : OPC Test 
; Version   : v2.2
; Erstellt  : 15.05.2009
; Gendert  : 
; Author    : Michael Kastner (mk-soft)

; Compiler  : Unicode

; *********************************************************************************************************

IncludeFile "PBOPC.pbi"
IncludeFile "PBOPC_Help.pbi"

; *********************************************************************************************************

#OPC_QUALITY_BAD = $00
#OPC_QUALITY_UNCERTAIN = $40
#OPC_QUALITY_GOOD = $C0
#OPC_QUALITY_CONFIG_ERROR = $04
#OPC_QUALITY_NOT_CONNECTED = $08
#OPC_QUALITY_DEVICE_FAILURE = $0c
#OPC_QUALITY_SENSOR_FAILURE = $10
#OPC_QUALITY_LAST_KNOWN = $14
#OPC_QUALITY_COMM_FAILURE = $18
#OPC_QUALITY_OUT_OF_SERVICE = $1C
#OPC_QUALITY_LAST_USABLE = $44
#OPC_QUALITY_SENSOR_CAL = $50
#OPC_QUALITY_EGU_EXCEEDED = $54
#OPC_QUALITY_SUB_NORMAL = $58
#OPC_QUALITY_LOCAL_OVERRIDE = $D8

; *********************************************************************************************************

Procedure test()
; OPC Server verbinden
  Debug "OPC Server verbinden"
  *Server = OpcConnect("ABB.IRC5.OPC.Server.DA.1", "")
  Debug GetErrorString(*Server, OpcGetLastError())
  If *Server = 0
    ProcedureReturn 0
  EndIf
  Debug "Fertig."
  ; Gruppe anlegen
  Debug "Gruppe anlegen"
  *Group = OpcAddGroup(*Server, "Test")
  Debug GetErrorString(*Server, OpcGetLastError())
  If *Group = 0
    ProcedureReturn 0
  EndIf
  ; Items anlegen
  Debug "Items anlegen"
  prefix.s = "W2K3_System3."
  *item1 = OpcAddItem(*Group, "", prefix + "SystemClock")
  *item2 = OpcAddItem(*Group, "", prefix + "IOSYSTEM.IOSIGNALS.DRV1K1")
  *item3 = OpcAddItem(*Group, "", prefix + "IOSYSTEM.IOSIGNALS.DRV1K2")
  Debug *item1
  Debug *item2
  Debug *item3
  
  Debug "Fertig."
  
  
  ; wait for plc
  Debug "PLC Verbinung pfen"
  datum.s = Space(100)
  value1.l
  value2.l
  quality.l
  
  
  Repeat
    r1 = OpcReadString(*item1, @datum, 100, @quality)
    Debug "Item 1 gelesen: " + datum + " Quality: " + GetQualityText(quality)
    If r1
      Debug GetErrorString(*Server, r1)
      OpcRelease(*server)
      End
    EndIf
    If quality = #OPC_QUALITY_GOOD
      Break
    Else
      count + 1
      If count > 10
        OpcRelease(*Server)
        Debug "PLC Offline"
        End
      EndIf
    EndIf
  ForEver
  Debug "Fertig."
  
  Debug "Daten lesen... "
  For i = 1 To 5
    r1 = OpcReadString(*item1, @datum, 100, @quality)
    If r1
      Debug GetErrorString(*Server, r1)
    Else
      Debug "Item 1 gelesen: " + datum + " Quality: " + GetQualityText(quality)
    EndIf
    r1 = OpcReadLong(*item2, @value1, @quality)
    If r1
      Debug GetErrorString(*Server, r1)
    Else
      Debug "Item 2 gelesen: " + Str(value1) + " Quality: " + GetQualityText(quality)
    EndIf
    r1 = OpcReadLong(*item3, @value2, @quality)
    If r1
      Debug GetErrorString(*Server, r1)
    Else
      Debug "Item 3 gelesen: " + Str(value2) + " Quality: " + GetQualityText(quality)
    EndIf
    Delay(1000)
  Next
  
  ; Server beenden - Intern werden automatisch die Gruppen gelscht (OpcRemoveGroup(...))
  Debug "Beenden Server"
  hResult = OpcRelease(*Server)
  Debug "Fertig"
  
EndProcedure

test()

; IDE Options = PureBasic 4.31 (Windows - x86)
; CursorPosition = 12
; Folding = -
; EnableUnicode